unit Fenstertest1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, XMLConf, FileUtil, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Grids, XMLPropStorage;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    lTitel: TLabel;
    lSchlagw: TLabel;
    lRubrik: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    sgRubrik1: TStringGrid;
    sgTitel: TStringGrid;
    sgSchlagw: TStringGrid;
    sgRubrik: TStringGrid;
    StringGrid1: TStringGrid;
    XMLPropStorage1: TXMLPropStorage;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

const
  rbr=8;  {Breite der Rahmen}

implementation

{$R *.lfm}

{ Fenster mit Controls, die Größe und Position entsprechend der
  Fenstergröße ändern.

  Ich habe das mit verschachtelten Panels gemacht. Ob das elegant ist,
  weiß ich nicht, aber es geht und so mache ich das eben üblicherweise.

  1. TXMLPropStorage aufs Formular gelegt, um Programmeinstellungen zu speichern
     (Session Properties) für Form1 - hier die Fenstergröße Width und Hight.
     Kann man auch woanders speicher, INI oder so.
  2. Constraints für das Fenster auf Minimum gestellt.
  3. Panel 1 und Panel 2 um das Fenster vertikal aufzuteilen.
     Panel 1 Rahmen ausblenden.
  4. Panel 3, 4, 5 um das linke Panel horizontal zu teilen.
  5. Berechnen der Breiten und Positionen, geschickt Anchors und ggf. Align nutzen.

  Man kann noch mit Borderspacing der Panels was machen, siehe Panel3/4
  Rahmen der Panels kann man auch ausblenden (Bevel: bvNone),
  siehe die ganzen Controls unten links und eben Panel1.
}

procedure TForm1.FormResize(Sender: TObject); {Hier berechnen wir die Höhen/Breiten}
begin
//Vertikale Teilung 3:1
  Panel1.Width:=((Form1.Width-3*rbr) div 4)*3;
  Panel2.Width:=Form1.Width-Panel1.Width-3*rbr;
  Panel2.Left:=Panel1.Width+2*rbr;
//Horizontale Teilung durch 3, also drei nebeneinander
  sgTitel.Width:=(Panel1.Width-4*rbr) div 3;
  sgSchlagw.Width:=sgTitel.Width;
  sgRubrik.Width:=sgTitel.Width;     {alle drei gleich breit}
  sgTitel.Left:=rbr;
  sgSchlagw.Left:=sgTitel.Left+sgTitel.Width+rbr;
  sgRubrik.Left:=sgSchlagw.Left+sgSchlagw.Width+rbr;
//Die anderen Controls 'mitziehen'
  lTitel.Left:=sgTitel.Left;
  lSchlagw.Left:=sgSchlagw.Left;
  lRubrik.Left:=sgRubrik.Left;
//Unten auch
  Panel6.Width:=sgTitel.Width;
  Panel6.Left:=sgTitel.Left;
  Panel7.Width:=sgSchlagw.Width;
  Panel7.Left:=sgSchlagw.Left;
  Panel8.Width:=sgRubrik.Width;
  Panel8.Left:=sgRubrik.Left;
//usw. mit viel Aufwand

  Form1.Refresh;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//Rahmen einstellen
  Panel3.BorderSpacing.Bottom:=rbr;
  Panel4.BorderSpacing.Bottom:=rbr;
end;

end.

