unit Fenster2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Grids;

type

  { TForm2 }

  TForm2 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Pn_rereob: TPanel;
    Pn_liu: TPanel;
    Pn_liob: TPanel;
    Pn_Links: TPanel;
    Pn_lim: TPanel;
    Pn_lir: TPanel;
    Pn_reob: TPanel;
    Pn_miob: TPanel;
    Pn_Mitte: TPanel;
    Pn_rechts: TPanel;
    Pn_rereun: TPanel;
    StringGridli: TStringGrid;
    StringGridrereob: TStringGrid;
    StringGridmi: TStringGrid;
    StringGridre: TStringGrid;
    StringGridrereun: TStringGrid;

    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    Function Berechnen ( A_Position , A_Faktor : integer) : integer;

  private

  public

  end;

var
  Form2: TForm2;

implementation

{$R *.lfm}

{ TForm2 }

procedure TForm2.FormResize(Sender: TObject);
var
  A_Raster_W ,  Pn_rereob_Left , A_Weite , A_Hoehe , Faktor_W , Faktor_H ,Pn_Mitte_Left , Pn_rechts_Left   : integer;

begin

// Ausgangspositionen

   A_Weite := 600;
   A_Hoehe := 400;

   A_Raster_W := A_Weite div 17;

   Pn_Mitte_Left  := A_Raster_W * 5;
   Pn_rechts_Left := A_Raster_W * 9;
   Pn_rereob_Left := A_Raster_W * 13;


// Faktorberechnung

Faktor_W  :=  Form2.Width div (A_Weite div 200 );
Faktor_H  :=  Form2.Height div (A_Hoehe div 200 );

Edit1.Text:= inttostr(Faktor_W);
Edit2.Text:= inttostr(Faktor_H);

//////////////////////////////////


 Pn_Links.Left  :=   0 ;
 Pn_Mitte.Left  :=   Berechnen ( Pn_Mitte_Left  , Faktor_W ) ;
 Pn_Rechts.Left :=   Berechnen ( Pn_rechts_Left , Faktor_W ) ;
 Pn_rereob.Left :=   Berechnen ( Pn_rereob_Left , Faktor_W ) ;

 Pn_Links.Height  :=   Berechnen ( A_Hoehe , Faktor_H ) ;
 Pn_Mitte.Height  :=   Pn_Links.Height;
 Pn_Rechts.Height :=   Pn_Links.Height;



 Pn_Links.Width  :=   Berechnen ( A_Raster_W * 5 , Faktor_W ) ;
 Pn_Mitte.Width  :=   Berechnen ( A_Raster_W * 4,  Faktor_W ) ;
 Pn_Rechts.Width :=   Pn_Mitte.Width;
 Pn_rereob.Width :=   Pn_Mitte.Width;
 Pn_rereob.Height:=   Form2.Height div 10 * 4;

 Pn_rereun.Left   :=   Pn_rereob.Left ;
 Pn_rereun.Width  :=   Pn_Mitte.Width;
 Pn_rereun.Top    :=   Pn_rereob.Height;
 Pn_rereun.Height :=   Form2.Height div 10 * 6;

////////////////

 Pn_liob.top:=6;
 Pn_miob.top:=6;
 Pn_reob.top:=6;

 Pn_liob.Left:=6;
 Pn_miob.Left:=6;
 Pn_reob.Left:=6;

 Pn_liob.Height:=50;
 Pn_miob.Height:=50;
 Pn_reob.Height:=50;

 Pn_liob.Width   := Pn_links.Width - 12;
 Pn_miob.Width   := Pn_mitte.Width - 12;
 Pn_reob.Width   := Pn_miob.Width;

 StringGridli.top := Pn_liob.Height + 12;
 StringGridmi.top := StringGridli.top;
 StringGridre.top := StringGridli.top;

 StringGridli.left := 6;
 StringGridmi.left := 6;
 StringGridre.left := 6;

 StringGridli.Width := Pn_liob.Width;
 StringGridmi.Width := Pn_miob.Width;
 StringGridre.Width := Pn_miob.Width;

 StringGridli.Height := Pn_Links.Height - Pn_liob.Height - Pn_liu.Height - 18;
 StringGridmi.Height := StringGridli.Height;
 StringGridre.Height := StringGridli.Height;

//

 StringGridrereob.Top := 40;
 StringGridrereob.left := 6;
 StringGridrereob.Width:= Pn_rereob.Width - 12;
 StringGridrereob.Height:= Pn_rereob.Height - 80;

 StringGridrereun.Top:= 45;
 StringGridrereun.Left:= StringGridrereob.left;
 StringGridrereun.Width:=StringGridrereob.Width;
 StringGridrereun.Height:=Pn_rereun.Height - 50;


end;

procedure TForm2.FormCreate(Sender: TObject);
begin
    Form2.Height:=450;
    Form2.Width:=730;
    Form2.Constraints.MinHeight:=370;
    Form2.Constraints.MaxHeight:=850;
    Form2.Constraints.MinWidth:=680;
    Form2.Constraints.MaxWidth:=950;
end;


Function TForm2.Berechnen ( A_Position , A_Faktor : integer ) : integer;
begin
    Result := ( A_Position * A_Faktor )  div 200 ;
end;

end.

